### Method

# FwupdPlugin Device close

since: 1.1.2

#### Declaration [src]

    gboolean
    fu_device_close (
      FuDevice* self
      GError** error
    )

#### Description [src]

Closes a device, optionally running a object-specific vfunc.

Plugins can call `fu_device_close()` multiple times without calling fu_device_open(), but only the last call will actually invoke the vfunc.

It is expected that plugins issue the same number of `fu_device_open()` and `fu_device_close()` methods when using a specific `self`.

An error is returned if this method is called without having used the `fu_device_open()` method beforehand.

If the close action completed successfully the internal device flag `FU_DEVICE_INTERNAL_FLAG_IS_OPEN` will be cleared.

Available since: 1.1.2

#### Return value

Type: `gboolean`

`TRUE` for success.